# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class Species(str, enum.Enum):
    """
    Zoological Taxonomy - like "dog", "cat", etc.
    Take a look [Species](https://en.wikipedia.org/wiki/Species).
    """

    CAT = "CAT"
    DOG = "DOG"
    PARROT = "PARROT"

    def visit(
        self,
        cat: typing.Callable[[], T_Result],
        dog: typing.Callable[[], T_Result],
        parrot: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is Species.CAT:
            return cat()
        if self is Species.DOG:
            return dog()
        if self is Species.PARROT:
            return parrot()
